;*************************************************************** 
;* 
;* LED villogtatst bemutat program
;* 
;* A C port 2-es bitjn lv LED-et villogtatja, timer hasznlata nlkl.
;* 
;*************************************************************** 
;* 
;*  Kszitette: 
;*  Csoport:
;*  Dtum: 
;* 
;*************************************************************** 
 
.include "m128def.inc"  		; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;*************************************************************** 
.equ	LEDnr	= 2
.equ	LEDmask = 1<<LEDnr
;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def	mpr1 = R16				; ltalnos felhasznls regiszterek
.def	mpr2 = R17
.def	cnt1 = R18				; Szmllk a ksleltetshez
.def	cnt2 = R19

;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg 
.org 0x0000      				; Kdszegmens kezdcme

		jmp	init				; Reset vektor 
.org 0x0047						;	megszakts tbla vge	
;*****************************************************************************
;* Inicializls
;*****************************************************************************

//A stack-et az SRAM vgre inicializljuk
//A kvetkez sorok a Stack Pointer regiszterbe tltik az SRAM vgt
init:	ldi		mpr1,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr1			; (ld."m128def.inc") 
		ldi		mpr1,HIGH(RAMEND)
		out		SPH,mpr1

;*****************************************************************************
;* Fprogram
;*****************************************************************************		

main:
		sbi		DDRC,LEDnr
		ldi		mpr2,LEDmask
		ldi		cnt1,4
		ldi		cnt2,4
loop:
		in		mpr1,PORTC
		eor		mpr1,mpr2
		out		PORTC,mpr1
		call	delay
		jmp		loop;			; Vgtelen hurok
		
;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

; Ksleltets (bemenetek: cnt1 s cnt2)

delay:
		push	mpr1	;betltjk a stack pointer ltal mutatott cmre az mpr1 rtkt
		push	cnt1
		push	cnt2
del0:
		ldi		cnt1, 4
del1:
		ldi		mpr1, 4
del2:	
		dec		mpr1	;cskkentjk mpr1-et				R16
		brne	del2	;ha nem nulla ugrik del2-re			
		dec		cnt1	;cskkentjk cnt1-et				R18
	 	brne	del1	;ha nem nulla ugrik del1-re	
		dec		cnt2	;cskkentjk cnt2-t					R19
		brne	del0	;ha nem nulla ugrik del0-ra
		pop		cnt2
		pop		cnt1
		pop		mpr1
		ret	

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************

;*****************************************************************************
;* Adatok
;*****************************************************************************
